'' =================================================================================================
''
''   File....... blinker.spin
''   Purpose.... 
''   Author..... 
''               
''               
''   E-mail..... 
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


var

  long  cog

  long  blinkpin                                                ' pin used by blinker cog
  long  onticks                                                 ' pin "on" timing in system ticks 
  long  offticks                                                ' pin "off" timing in system ticks
  

pub start(pin, onms, offms)

'' Start blinking pin with specified on and off durations (in milliseconds)

  stop                                                          ' stop if already running

  blinkpin := pin
  onticks  := clkfreq / 1000 * onms
  offticks := clkfreq / 1000 * offms

  result := cog := cognew(@blinker, @blinkpin)                  ' start blinker cog
   

pub stop

'' Stops blinker cog if running

  if (cog)
    cogstop(cog~ - 1)                                           ' stop cog, clear id


pub active

'' Returns non-zero (true) if blinker is active

  return cog
  

con

dat

                        org     0

blinker                 mov     t1, par                         ' start of structure
                        rdlong  t2, t1                          ' read blink pin
                        mov     pinmask, #1                     ' create mask from pin #
                        shl     pinmask, t2

                        add     t1, #4                          ' point to "on" ticks
                        rdlong  ontix, t1                       ' read on timing

                        add     t1, #4                          ' point to "off" ticks
                        rdlong  offtix, t1                      ' read off timing

                        mov     dira, pinmask                   ' make pin an output
                        or      outa, pinmask                   ' start on

                        mov     timer, ontix                    ' start with on time
                        add     timer, cnt                      ' sync with system counter

bloop                   waitcnt timer, offtix                   ' let on time expire, load off time
                        andn    outa, pinmask                   ' pin off
                        waitcnt timer, ontix                    ' let off time expire, load on time
                        or      outa, pinmask                   ' pin on
                        jmp     #bloop                          ' loop forever
                          
' --------------------------------------------------------------------------------------------------

pinmask                 res     1                               ' mask for blinker pin
ontix                   res     1                               ' on timing in system ticks
offtix                  res     1                               ' off timing in system ticks
timer                   res     1

t1                      res     1
t2                      res     1


                        fit     496                                    

                        
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}  